## kpimtextedit 22.12.3

=== CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
cmake_minimum_required(VERSION 3.16 FATAL_ERROR)
set(PIM_VERSION "5.22.3")

project(KPimTextEdit VERSION ${PIM_VERSION})

# ECM setup
set(KF5_MIN_VERSION "5.99.0")

find_package(ECM ${KF5_MIN_VERSION} CONFIG REQUIRED)
set(CMAKE_MODULE_PATH ${ECM_MODULE_PATH})


include(KDEInstallDirs)
include(KDECMakeSettings)
include(KDECompilerSettings NO_POLICY_SCOPE)

include(GenerateExportHeader)
include(ECMGenerateHeaders)
include(ECMGeneratePriFile)

include(ECMSetupVersion)
include(FeatureSummary)
include(KDEGitCommitHooks)
include(KDEClangFormat)
file(GLOB_RECURSE ALL_CLANG_FORMAT_SOURCE_FILES *.cpp *.h *.c)
kde_clang_format(${ALL_CLANG_FORMAT_SOURCE_FILES})

include(ECMAddTests)
include(ECMQtDeclareLoggingCategory)
include(ECMDeprecationSettings)

include(ECMAddQch)


option(BUILD_QCH "Build API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)" OFF)
add_feature_info(QCH ${BUILD_QCH} "API documentation in QCH format (for e.g. Qt Assistant, Qt Creator & KDevelop)")

set(KPIMTEXTEDIT_LIB_VERSION ${PIM_VERSION})

ecm_setup_version(PROJECT VARIABLE_PREFIX KPIMTEXTEDIT
    VERSION_HEADER "${CMAKE_CURRENT_BINARY_DIR}/kpimtextedit_version.h"
    PACKAGE_VERSION_FILE "${CMAKE_CURRENT_BINARY_DIR}/KF5PimTextEditConfigVersion.cmake"
    SOVERSION 5
)

set(QT_REQUIRED_VERSION "5.15.2")
if (QT_MAJOR_VERSION STREQUAL "6")
    set(QT_REQUIRED_VERSION "6.4.0")
endif()	
find_package(Qt${QT_MAJOR_VERSION} ${QT_REQUIRED_VERSION} CONFIG REQUIRED COMPONENTS Widgets)

########### Find packages ###########
find_package(KF5Config ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5ConfigWidgets ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5CoreAddons ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5I18n ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5IconThemes ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5KIO ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5Sonnet ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5SyntaxHighlighting ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5WidgetsAddons ${KF5_MIN_VERSION} CONFIG REQUIRED)
find_package(KF5XmlGui ${KF5_MIN_VERSION} CONFIG REQUIRED)

option(USE_UNITY_CMAKE_SUPPORT "Use UNITY cmake support (speedup compile time)" OFF)

set(COMPILE_WITH_UNITY_CMAKE_SUPPORT OFF)
if (USE_UNITY_CMAKE_SUPPORT)
    set(COMPILE_WITH_UNITY_CMAKE_SUPPORT ON)
endif()


option(BUILD_DESIGNERPLUGIN "Build plugin for Qt Designer" ON)
add_feature_info(DESIGNERPLUGIN ${BUILD_DESIGNERPLUGIN} "Build plugin for Qt Designer")

add_definitions(-DTRANSLATION_DOMAIN=\"libkpimtextedit\")

ecm_set_disabled_deprecation_versions(QT 5.15.2 KF 5.99.0)



find_package(Qt${QT_MAJOR_VERSION}TextToSpeech ${QT_REQUIRED_VERSION} CONFIG)
set_package_properties(Qt${QT_MAJOR_VERSION}TextToSpeech PROPERTIES DESCRIPTION
    "Add support for text to speech"
    TYPE OPTIONAL
)
if(TARGET Qt::TextToSpeech)
    add_definitions(-DHAVE_TEXT_TO_SPEECH_SUPPORT)
    set(KPIMTEXTEDIT_TEXT_TO_SPEECH TRUE)
endif()

configure_file(kpimtextedit-texttospeech.h.cmake ${CMAKE_CURRENT_BINARY_DIR}/kpimtextedit-texttospeech.h )


if (QT_MAJOR_VERSION STREQUAL "6")
    find_package(Qt6Core5Compat)
endif()

if(BUILD_TESTING)
   find_package(Qt${QT_MAJOR_VERSION} ${QT_REQUIRED_VERSION} CONFIG REQUIRED COMPONENTS Test)
   add_definitions(-DBUILD_TESTING)
endif()

########### Targets ###########
add_subdirectory(src)

if(BUILD_TESTING)
    find_package(KF5TextWidgets ${KF5_MIN_VERSION} CONFIG REQUIRED)
    add_subdirectory(autotests)
    add_subdirectory(tests)
endif()

########### CMake Config Files ###########
set(CMAKECONFIG_INSTALL_DIR "${KDE_INSTALL_CMAKEPACKAGEDIR}/KF5PimTextEdit")

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/KF5PimTextEditConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/KF5PimTextEditConfig.cmake"
    INSTALL_DESTINATION ${CMAKECONFIG_INSTALL_DIR}
    )

install(FILES
    "${CMAKE_CURRENT_BINARY_DIR}/KF5PimTextEditConfig.cmake"
    "${CMAKE_CURRENT_BINARY_DIR}/KF5PimTextEditConfigVersion.cmake"
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    COMPONENT Devel
    )

install(EXPORT KF5PimTextEditTargets
    DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
    FILE KF5PimTextEditTargets.cmake
    NAMESPACE KF5::
    )

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kpimtextedit_version.h
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KPIMTextEdit
    COMPONENT Devel
    )


if (BUILD_QCH)
    ecm_install_qch_export(
        TARGETS KF5PimTextEdit_QCH
        FILE KF5PimTextEditQchTargets.cmake
        DESTINATION "${CMAKECONFIG_INSTALL_DIR}"
        COMPONENT Devel
    )
    set(PACKAGE_INCLUDE_QCHTARGETS "include(\"\${CMAKE_CURRENT_LIST_DIR}/KF5PimTextEditQchTargets.cmake\")")
endif()

kde_configure_git_pre_commit_hook(CHECKS CLANG_FORMAT)
ki18n_install(po)
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

=== autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
include(ECMAddTests)

ecm_add_test(textutilstest.cpp textutilstest.h
    TEST_NAME textutilstest
    NAME_PREFIX "kpimtextedit-"
    LINK_LIBRARIES Qt::Test Qt::Widgets KF5::Codecs KF5PimTextEdit KF5::TextWidgets KF5::XmlGui)

ecm_add_test(editorutiltest.cpp editorutiltest.h
    TEST_NAME editorutiltest
    NAME_PREFIX "kpimtextedit-"
    LINK_LIBRARIES Qt::Test Qt::Widgets KF5::Codecs KF5PimTextEdit KF5::TextWidgets KF5::XmlGui)

ecm_add_test(emoticonunicodetabtest.cpp emoticonunicodetabtest.h
    TEST_NAME emoticonunicodetabtest
    NAME_PREFIX "kpimtextedit-"
    LINK_LIBRARIES Qt::Test Qt::Widgets KF5::Codecs KF5PimTextEdit KF5::TextWidgets KF5::XmlGui)

ecm_add_test(slidecontainertest.cpp slidecontainertest.h
    TEST_NAME slidecontainertest
    NAME_PREFIX kpimtextedit-widget
    LINK_LIBRARIES Qt::Test Qt::Gui KF5::PimTextEdit Qt::Widgets
    )

=== src/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_library(KF5PimTextEdit)
add_library(KF5::PimTextEdit ALIAS KF5PimTextEdit)


target_sources(KF5PimTextEdit PRIVATE
    texteditor/plaintexteditor/plaintexteditfindbar.cpp
    texteditor/plaintexteditor/plaintexteditor.cpp
    texteditor/plaintexteditor/plaintexteditorwidget.cpp
    texteditor/plaintexteditor/plaintextsyntaxspellcheckinghighlighter.cpp
    texteditor/commonwidget/findutils.cpp
    texteditor/commonwidget/textfindreplacewidget.cpp
    texteditor/commonwidget/texteditfindbarbase.cpp
    texteditor/commonwidget/textgotolinewidget.cpp
    texteditor/commonwidget/textmessageindicator.cpp
    texteditor/richtexteditor/richtexteditor.cpp
    texteditor/richtexteditor/richtexteditfindbar.cpp
    texteditor/richtexteditor/richtexteditorwidget.cpp
    texteditor/plaintexteditor/plaintexteditfindbar.h
    texteditor/plaintexteditor/plaintexteditor.h
    texteditor/plaintexteditor/plaintexteditorwidget.h
    texteditor/plaintexteditor/plaintextsyntaxspellcheckinghighlighter.h
    texteditor/commonwidget/findutils.h
    texteditor/commonwidget/textfindreplacewidget.h
    texteditor/commonwidget/texteditfindbarbase.h
    texteditor/commonwidget/textgotolinewidget.h
    texteditor/commonwidget/textmessageindicator.h
    texteditor/richtexteditor/richtexteditor.h
    texteditor/richtexteditor/richtexteditfindbar.h
    texteditor/richtexteditor/richtexteditorwidget.h
    )

target_sources(KF5PimTextEdit PRIVATE
    composer-ng/richtextcomposer.cpp
    composer-ng/richtextcomposercontroler.cpp
    composer-ng/richtextcomposeractions.cpp
    composer-ng/klinkdialog.cpp
    composer-ng/nestedlisthelper.cpp
    composer-ng/richtextexternalcomposer.cpp
    composer-ng/richtextcomposerimages.cpp
    composer-ng/richtextcomposeremailquotedecorator.cpp
    composer-ng/richtextcomposeremailquotehighlighter.cpp
    composer-ng/richtextcomposerwidget.cpp
    composer-ng/richtextcomposer.h
    composer-ng/richtextcomposercontroler.h
    composer-ng/richtextcomposeractions.h
    composer-ng/klinkdialog_p.h
    composer-ng/nestedlisthelper_p.h
    composer-ng/richtextexternalcomposer.h
    composer-ng/richtextcomposerimages.h
    composer-ng/richtextcomposeremailquotedecorator.h
    composer-ng/richtextcomposeremailquotehighlighter.h
    composer-ng/richtextcomposerwidget.h
    )
if (KPIMTEXTEDIT_TEXT_TO_SPEECH)
    target_sources(KF5PimTextEdit PRIVATE
        texttospeech/texttospeech.cpp
        texttospeech/texttospeechwidget.cpp
        texttospeech/texttospeechconfigwidget.cpp
        texttospeech/texttospeechinterface.cpp
        texttospeech/abstracttexttospeechinterface.cpp
        texttospeech/abstracttexttospeechconfiginterface.cpp
        texttospeech/texttospeechconfiginterface.cpp
        texttospeech/texttospeechconfigdialog.cpp
        texttospeech/texttospeechlanguagecombobox.cpp
        texttospeech/texttospeechactions.cpp
        texttospeech/texttospeech.h
        texttospeech/texttospeechwidget.h
        texttospeech/texttospeechconfigwidget.h
        texttospeech/texttospeechinterface.h
        texttospeech/abstracttexttospeechinterface.h
        texttospeech/abstracttexttospeechconfiginterface.h
        texttospeech/texttospeechconfiginterface.h
        texttospeech/texttospeechconfigdialog.h
        texttospeech/texttospeechlanguagecombobox.h
        texttospeech/texttospeechactions.h
    )
endif()

target_sources(KF5PimTextEdit PRIVATE
    grantleebuilder/plaintextmarkupbuilder.cpp
    grantleebuilder/markupdirector.cpp
    grantleebuilder/texthtmlbuilder.cpp
    grantleebuilder/plaintextmarkupbuilder.h
    grantleebuilder/markupdirector.h
    grantleebuilder/texthtmlbuilder.h
    )

target_sources(KF5PimTextEdit PRIVATE
    emoticon/emoticontexteditaction.cpp
    emoticon/emoticontexteditselector.cpp
    emoticon/emoticonunicodetab.cpp
    emoticon/emoticonunicodeutils.cpp
    emoticon/emoticonunicodemodel.cpp
    emoticon/emoticonlistview.cpp
    emoticon/emoticonunicodeproxymodel.cpp
    emoticon/emoticonunicodemodelmanager.cpp
    emoticon/emoticonrecentusedfilterproxymodel.cpp
    emoticon/emoticonrecentlistview.cpp

    emoticon/emoticontexteditaction.h
    emoticon/emoticontexteditselector.h
    emoticon/emoticonunicodetab.h
    emoticon/emoticonunicodeutils.h
    emoticon/emoticonunicodemodel.h
    emoticon/emoticonlistview.h
    emoticon/emoticonunicodeproxymodel.h
    emoticon/emoticonunicodemodelmanager.h
    emoticon/emoticonrecentusedfilterproxymodel.h
    emoticon/emoticonrecentlistview.h
    )

target_sources(KF5PimTextEdit PRIVATE
    inserthtmldialog.cpp
    insertimagedialog.cpp
    insertimagewidget.cpp
    inserttabledialog.cpp
    selectspecialchardialog.cpp
    tableactionmenu.cpp
    tablecellformatdialog.cpp
    tableformatdialog.cpp
    textutils.cpp
    inserttablewidget.cpp
    texteditorcompleter.cpp
    inserthtmleditor.cpp
    slidecontainer.cpp
    editorutil.cpp

    inserthtmldialog.h
    insertimagedialog.h
    insertimagewidget.h
    inserttabledialog.h
    selectspecialchardialog.h
    tableactionmenu.h
    tablecellformatdialog.h
    tableformatdialog.h
    textutils.h
    inserttablewidget.h
    texteditorcompleter.h
    inserthtmleditor.h
    slidecontainer.h
    editorutil.h
    )

ecm_qt_declare_logging_category(KF5PimTextEdit HEADER kpimtextedit_debug.h IDENTIFIER KPIMTEXTEDIT_LOG CATEGORY_NAME org.kde.pim.kpimtextedit
        DESCRIPTION "kpimtextedit (kpimtextedit)" EXPORT KPIMTEXTEDIT)


if (COMPILE_WITH_UNITY_CMAKE_SUPPORT)
    set_target_properties(KF5PimTextEdit PROPERTIES UNITY_BUILD ON)
endif()
generate_export_header(KF5PimTextEdit BASE_NAME kpimtextedit)


target_include_directories(KF5PimTextEdit INTERFACE "$<INSTALL_INTERFACE:${KDE_INSTALL_INCLUDEDIR_KF}/KPIMTextEdit;>")
target_include_directories(KF5PimTextEdit PUBLIC "$<BUILD_INTERFACE:${KPimTextEdit_SOURCE_DIR}/src;${KPimTextEdit_BINARY_DIR}/src>")


target_link_libraries(KF5PimTextEdit
    PRIVATE
    KF5::SonnetUi
    KF5::SonnetCore
    KF5::WidgetsAddons
    KF5::KIOWidgets
    KF5::ConfigWidgets
    KF5::XmlGui
    KF5::I18n
    KF5::SyntaxHighlighting
    )
if (KPIMTEXTEDIT_TEXT_TO_SPEECH)
    target_link_libraries(KF5PimTextEdit
        PRIVATE
        Qt::TextToSpeech
        )
endif()
set_target_properties(KF5PimTextEdit PROPERTIES
    VERSION ${KPIMTEXTEDIT_VERSION}
    SOVERSION ${KPIMTEXTEDIT_SOVERSION}
    EXPORT_NAME PimTextEdit
    )

install(TARGETS KF5PimTextEdit EXPORT KF5PimTextEditTargets ${KF_INSTALL_TARGETS_DEFAULT_ARGS})

########### Generate Headers ###############
ecm_generate_headers(KPimTextEdit_CamelCase_HEADERS
    HEADER_NAMES
    EditorUtil
    SelectSpecialCharDialog
    SlideContainer
    TextEditorCompleter
    TextUtils

    PREFIX KPIMTextEdit
    REQUIRED_HEADERS kpimtextedit_HEADERS
    )

ecm_generate_headers(KPimTextEdit_CamelCaseemoticon_HEADERS
    HEADER_NAMES
    EmoticonUnicodeTab
    PREFIX KPIMTextEdit
    REQUIRED_HEADERS kpimtextedit_HEADERS
    RELATIVE emoticon
    )

ecm_generate_headers(KPimTextEdit_CamelCasegrantlee_HEADERS
    HEADER_NAMES
    PlainTextMarkupBuilder
    TextHTMLBuilder
    MarkupDirector
    AbstractMarkupBuilder
    PREFIX KPIMTextEdit
    REQUIRED_HEADERS kpimtextedit_HEADERS
    RELATIVE grantleebuilder
    )

ecm_generate_headers(KPimTextEdit_CamelCasetextrichtexteditor_HEADERS
    HEADER_NAMES
    RichTextEditorWidget
    RichTextEditor
    RichTextEditFindBar
    REQUIRED_HEADERS KPimTextEdit_richtexteditor_HEADERS
    PREFIX KPIMTextEdit
    RELATIVE texteditor/richtexteditor
    )

ecm_generate_headers(KPimTextEdit_CamelCaseplaintexteditor_HEADERS
    HEADER_NAMES
    PlainTextEditor
    PlainTextEditorWidget
    PlainTextEditFindBar
    PlainTextSyntaxSpellCheckingHighlighter
    REQUIRED_HEADERS KPimTextEdit_plaintexteditor_HEADERS
    PREFIX KPIMTextEdit
    RELATIVE texteditor/plaintexteditor
    )

ecm_generate_headers(KPimTextEdit_CamelCasetexteditor_commonwidget_HEADERS
    HEADER_NAMES
    TextGotoLineWidget
    TextEditFindBarBase
    REQUIRED_HEADERS KPimTextEdit_texteditor_commonwidget_HEADERS
    PREFIX KPIMTextEdit
    RELATIVE texteditor/commonwidget
    )


if (KPIMTEXTEDIT_TEXT_TO_SPEECH)
    ecm_generate_headers(KPimTextEdit_CamelCasetexttospeechs_HEADERS
        HEADER_NAMES
        TextToSpeech
        TextToSpeechActions
        TextToSpeechInterface
        TextToSpeechWidget
        AbstractTextToSpeechInterface
        REQUIRED_HEADERS KPimTextEdit_texttospeechs_HEADERS
        PREFIX KPIMTextEdit
        RELATIVE texttospeech
    )
endif()
ecm_generate_headers(KPimTextEdit_Camelcasecomposerng_HEADERS
    HEADER_NAMES
    RichTextComposer
    RichTextComposerControler
    RichTextComposerImages
    RichTextExternalComposer
    RichTextComposerActions
    RichTextComposerEmailQuoteHighlighter
    RichTextComposerWidget
    REQUIRED_HEADERS KPimTextEdit_composerng_HEADERS
    PREFIX KPIMTextEdit
    RELATIVE composer-ng
    )


########### install files ###############
if (KPIMTEXTEDIT_TEXT_TO_SPEECH)
    install(FILES
        ${KPimTextEdit_texttospeechs_HEADERS}
        DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KPIMTextEdit/kpimtextedit
        COMPONENT Devel
        )
    install(FILES
        ${KPimTextEdit_CamelCasetexttospeechs_HEADERS}
        DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KPIMTextEdit/KPIMTextEdit/
        COMPONENT Devel
        )
endif()

install(FILES
    ${CMAKE_CURRENT_BINARY_DIR}/kpimtextedit_export.h
    ${CMAKE_CURRENT_BINARY_DIR}/../kpimtextedit-texttospeech.h
    ${kpimtextedit_HEADERS}
    ${KPimTextEdit_richtexteditor_HEADERS}
    ${KPimTextEdit_texteditor_commonwidget_HEADERS}
    ${KPimTextEdit_plaintexteditor_HEADERS}
    ${KPimTextEdit_composerng_HEADERS}
    ${KPimTextEdit_emoticon_HEADERS}
    ${KPimTextEdit_grantlee_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KPIMTextEdit/kpimtextedit
    COMPONENT Devel
    )

install(FILES
    ${KPimTextEdit_CamelCase_HEADERS}
    ${KPimTextEdit_CamelCasetextrichtexteditor_HEADERS}
    ${KPimTextEdit_CamelCaseplaintexteditor_HEADERS}
    ${KPimTextEdit_CamelCasetexteditor_commonwidget_HEADERS}
    ${KPimTextEdit_Camelcasecomposerng_HEADERS}
    ${KPimTextEdit_CamelCaseemoticon_HEADERS}
    ${KPimTextEdit_CamelCasegrantlee_HEADERS}
    DESTINATION ${KDE_INSTALL_INCLUDEDIR_KF}/KPIMTextEdit/KPIMTextEdit/
    COMPONENT Devel
    )

ecm_generate_pri_file(BASE_NAME KPIMTextEdit LIB_NAME KF5PimTextEdit DEPS "" FILENAME_VAR PRI_FILENAME INCLUDE_INSTALL_DIR ${KDE_INSTALL_INCLUDEDIR_KF}/KPIMTextEdit/)
install(FILES ${PRI_FILENAME} DESTINATION ${ECM_MKSPECS_INSTALL_DIR})

if (BUILD_TESTING)
    add_subdirectory(texteditor/plaintexteditor/autotests)
    add_subdirectory(texteditor/richtexteditor/autotests)
    add_subdirectory(texteditor/commonwidget/autotests)
    add_subdirectory(texteditor/plaintexteditor/tests)
    add_subdirectory(texteditor/richtexteditor/tests)
    if (KPIMTEXTEDIT_TEXT_TO_SPEECH)
        add_subdirectory(texttospeech/autotests)
        add_subdirectory(texttospeech/tests)
    endif()
    add_subdirectory(composer-ng/autotests)
    add_subdirectory(composer-ng/tests)
    add_subdirectory(grantleebuilder/autotests)
endif()

if(BUILD_DESIGNERPLUGIN)
    add_subdirectory(designer)
endif()

ecm_qt_install_logging_categories(EXPORT KPIMTEXTEDIT FILE kpimtextedit.categories DESTINATION ${KDE_INSTALL_LOGGINGCATEGORIESDIR})

if(BUILD_TESTING)
    add_subdirectory(emoticon/autotests)
endif()	

if (BUILD_QCH)
    ecm_add_qch(
        KF5PimTextEdit_QCH
        NAME KPimTextEdit
        BASE_NAME KF5PimTextEdit
        VERSION ${PIM_VERSION}
        ORG_DOMAIN org.kde
        SOURCES # using only public headers, to cover only public API
            ${kpimtextedit_HEADERS}
            ${KPimTextEdit_texttospeechs_HEADERS}
            ${KPimTextEdit_richtexteditor_HEADERS}
            ${KPimTextEdit_texteditor_commonwidget_HEADERS}
            ${KPimTextEdit_plaintexteditor_HEADERS}

=== tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
include_directories(${CMAKE_CURRENT_SOURCE_DIR}/../src ${CMAKE_CURRENT_BINARY_DIR}/../src)
#####
add_executable(inserthtmldialog_demo inserthtmldialog_demo.cpp)
set(inserthtmldialog_demo_LIBS KF5PimTextEdit Qt::Widgets KF5::SyntaxHighlighting)
target_link_libraries(inserthtmldialog_demo ${inserthtmldialog_demo_LIBS})
#####
add_executable(slidecontainer_gui slidecontainer_gui.cpp)
target_link_libraries(slidecontainer_gui
    Qt::Core
    Qt::Gui
    Qt::Widgets
    KF5PimTextEdit
    )

#####
add_executable(showemoticonunicodetab_gui showemoticonunicodetab_gui.cpp)
set(showemoticonunicodetab_gui_LIBS KF5PimTextEdit Qt::Widgets)
target_link_libraries(showemoticonunicodetab_gui ${showemoticonunicodetab_gui_LIBS})
#####
add_executable(testgeneratehtmlbuildergui_gui testgeneratehtmlbuildergui.cpp testgeneratehtmlbuildergui.h)
set(testgeneratehtmlbuildergui_gui_LIBS KF5PimTextEdit Qt::Widgets )
target_link_libraries(testgeneratehtmlbuildergui_gui ${testgeneratehtmlbuildergui_gui_LIBS})

#####
add_executable(testgenerateplaintextbuilder_gui testgenerateplaintextbuildergui.cpp testgenerateplaintextbuildergui.h)
set(testgenerateplaintextbuilder_gui_LIBS KF5PimTextEdit Qt::Widgets )
target_link_libraries(testgenerateplaintextbuilder_gui ${testgenerateplaintextbuilder_gui_LIBS})

=== src/composer-ng/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
macro(add_composer_ng_test _source)

    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(${_source} ${_name}.h
        TEST_NAME ${_name}
        NAME_PREFIX "kpimtextedit-composerng-"
        LINK_LIBRARIES Qt::Test KF5::PimTextEdit KF5::XmlGui KF5::IconThemes
    )
endmacro()

add_composer_ng_test(richtextcomposertest.cpp)
add_composer_ng_test(richtextcomposercontrolertest.cpp)
add_composer_ng_test(richtextcomposeractionstest.cpp)
add_composer_ng_test(richtextexternalcomposertest.cpp)
add_composer_ng_test(richtextcomposerimagestest.cpp)
add_composer_ng_test(richtextcomposerwidgettest.cpp)

=== src/grantleebuilder/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_definitions( -DGRANTLEEBUILDER_DIR="${CMAKE_CURRENT_SOURCE_DIR}/data" )
ecm_add_test(texthtmlbuildertest.cpp texthtmlbuildertest.h
    TEST_NAME texthtmlbuildertest
    NAME_PREFIX "kpimtextedit-grantleebuilder-"
    LINK_LIBRARIES KF5::PimTextEdit Qt::Test Qt::Widgets 
)

ecm_add_test(plaintextmarkupbuildertest.cpp plaintextmarkupbuildertest.h
    TEST_NAME plaintextmarkupbuildertest
    NAME_PREFIX "kpimtextedit-grantleebuilder-"
    LINK_LIBRARIES KF5::PimTextEdit Qt::Test Qt::Widgets
)

=== src/texttospeech/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
macro(add_kpimtextedit_texttospeech_unittest _source)
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(${_source} ${_name}.h TEST_NAME ${_name}
        NAME_PREFIX "kpimtextedit-texttospeech-"
        LINK_LIBRARIES Qt::Test KF5::PimTextEdit Qt::Widgets
        )
endmacro()

add_kpimtextedit_texttospeech_unittest( texttospeechwidgettest.cpp )
add_kpimtextedit_texttospeech_unittest( texttospeechconfigwidgettest.cpp )
add_kpimtextedit_texttospeech_unittest( texttospeechactionstest.cpp )

=== src/texteditor/commonwidget/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause

macro(add_kpimtextedit_commonwidget_unittest _source)
    get_filename_component(_name ${_source} NAME_WE)
    ecm_add_test(${_source} ${_name}.h TEST_NAME ${_name}
        NAME_PREFIX "kpimtextedit-plaintext-"
        LINK_LIBRARIES Qt::Test KF5::PimTextEdit Qt::Widgets
        )
endmacro()


add_kpimtextedit_commonwidget_unittest(textgotolinewidgettest.cpp)

add_kpimtextedit_commonwidget_unittest(textfindwidgettest.cpp)

add_kpimtextedit_commonwidget_unittest(textreplacewidgettest.cpp)

=== src/texteditor/plaintexteditor/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
ecm_add_test(plaintexteditortest.cpp plaintexteditortest.h
    TEST_NAME plaintexteditortest
    NAME_PREFIX "kpimtextedit-plaintexteditor-"
    LINK_LIBRARIES KF5::PimTextEdit KF5::KIOWidgets Qt::Test Qt::Widgets
)

ecm_add_test(plaintexteditfindbartest.cpp plaintexteditfindbartest.h
    TEST_NAME plaintexteditfindbartest
    NAME_PREFIX "kpimtextedit-plaintexteditor-"
    LINK_LIBRARIES KF5::PimTextEdit KF5::KIOWidgets Qt::Test Qt::Widgets
)

=== src/texteditor/plaintexteditor/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_executable(plaintexteditor_gui plaintexteditor_gui.cpp)
target_link_libraries(plaintexteditor_gui
  KF5::PimTextEdit KF5::CoreAddons Qt::Widgets KF5::I18n
)

=== src/texteditor/richtexteditor/autotests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
ecm_add_test(richtexteditortest.cpp richtexteditortest.h TEST_NAME richtexteditortest
    NAME_PREFIX "kpimtextedit-richtesteditor-"
    LINK_LIBRARIES KF5::PimTextEdit Qt::Test Qt::Widgets
)

ecm_add_test(richtexteditfindbartest.cpp richtexteditfindbartest.h TEST_NAME richtexteditfindbartest
    NAME_PREFIX "kpimtextedit-plaintexteditor-"
    LINK_LIBRARIES KF5::PimTextEdit Qt::Test Qt::Widgets
)

=== src/texteditor/richtexteditor/tests/CMakeLists.txt ===
# SPDX-FileCopyrightText: none
# SPDX-License-Identifier: BSD-3-Clause
add_executable(richtexteditor_gui richtexteditor_gui.cpp)
target_link_libraries(richtexteditor_gui
  KF5::PimTextEdit KF5::CoreAddons Qt::Widgets KF5::I18n
)

=== debian/changelog ===
kpimtextedit (22.12.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.3).
  * Update build-deps and deps with the info from cmake.
  * Remove inactive uploaders, thanks for your work.

 -- Patrick Franz <deltaone@debian.org>  Wed, 01 Mar 2023 21:31:13 +0100

kpimtextedit (22.12.2-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.2).

 -- Patrick Franz <deltaone@debian.org>  Sun, 05 Feb 2023 00:25:00 +0100

kpimtextedit (22.12.0-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Wed, 04 Jan 2023 21:36:15 +0100

kpimtextedit (22.12.0-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.12.0).
  * Update build-deps and deps with the info from cmake.
  * Bump Standards-Version to 4.6.2 (No changes needed).

 -- Patrick Franz <deltaone@debian.org>  Thu, 22 Dec 2022 21:02:20 +0100

kpimtextedit (22.08.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.08.3).

 -- Patrick Franz <deltaone@debian.org>  Fri, 04 Nov 2022 21:53:18 +0100

kpimtextedit (22.08.2-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.08.2).

 -- Patrick Franz <deltaone@debian.org>  Sat, 29 Oct 2022 00:10:26 +0200

kpimtextedit (22.08.0-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Sat, 10 Sep 2022 13:07:52 +0200

kpimtextedit (22.08.0-1) experimental; urgency=medium

  [ Patrick Franz ]
  * Update upstream signing-key.
  * Bump Standards-Version to 4.6.1 (No changes needed).
  * New upstream release (22.08.0).
  * Update build-deps and deps with the info from cmake.

 -- Patrick Franz <deltaone@debian.org>  Wed, 31 Aug 2022 01:45:02 +0200

kpimtextedit (22.04.3-1) unstable; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.04.3).

 -- Patrick Franz <deltaone@debian.org>  Thu, 14 Jul 2022 21:55:29 +0200

kpimtextedit (22.04.2-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Mon, 27 Jun 2022 22:00:21 +0200

kpimtextedit (22.04.2-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.04.2).

 -- Patrick Franz <deltaone@debian.org>  Sun, 19 Jun 2022 02:46:10 +0200

kpimtextedit (22.04.1-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (22.04.1).
  * Update build-deps and deps with the info from cmake.
  * Update list of installed files.

 -- Patrick Franz <deltaone@debian.org>  Wed, 25 May 2022 01:57:38 +0200

kpimtextedit (21.12.3-2) unstable; urgency=medium

  [ Patrick Franz ]
  * Upload to unstable.

 -- Patrick Franz <deltaone@debian.org>  Fri, 01 Apr 2022 22:09:01 +0200

kpimtextedit (21.12.3-1) experimental; urgency=medium

  [ Patrick Franz ]
  * New upstream release (21.12.3).
  * Update build-deps and deps with the info from cmake.
  * Add myself to Uploaders.

 -- Patrick Franz <deltaone@debian.org>  Thu, 24 Mar 2022 22:18:32 +0100

=== debian/control ===
Source: kpimtextedit
Section: libs
Priority: optional
Maintainer: Debian Qt/KDE Maintainers <debian-qt-kde@lists.debian.org>
Uploaders: Sandro Knauß <hefee@debian.org>,
           Patrick Franz <deltaone@debian.org>,
Build-Depends: breeze-icon-theme,
               cmake (>= 3.16~),
               debhelper-compat (= 13),
               extra-cmake-modules (>= 5.99.0~),
               libgrantlee5-dev (>= 5.2~),
               libkf5config-dev (>= 5.99.0~),
               libkf5configwidgets-dev (>= 5.99.0~),
               libkf5coreaddons-dev (>= 5.99.0~),
               libkf5i18n-dev (>= 5.99.0~),
               libkf5iconthemes-dev (>= 5.99.0~),
               libkf5kio-dev (>= 5.99.0~),
               libkf5sonnet-dev (>= 5.99.0~),
               libkf5syntaxhighlighting-dev (>= 5.99.0~),
               libkf5textwidgets-dev (>= 5.99.0~),
               libkf5widgetsaddons-dev (>= 5.99.0~),
               libkf5xmlgui-dev (>= 5.99.0~),
               libqt5texttospeech5-dev,
               openbox,
               pkg-kde-tools (>> 0.15.15),
               qtbase5-dev (>= 5.15.2~),
               qttools5-dev,
               qttools5-dev-tools,
               xauth,
               xvfb,
Standards-Version: 4.6.2
Homepage: https://invent.kde.org/pim/kpimtextedit
Vcs-Browser: https://salsa.debian.org/qt-kde-team/kde/kpimtextedit
Vcs-Git: https://salsa.debian.org/qt-kde-team/kde/kpimtextedit.git
Rules-Requires-Root: no

Package: libkf5pimtextedit-data
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
Description: libkf5pimtextedit - arch independent files
 KPIMTextedit provides a textedit with PIM-specific features. It also provides
 so-called rich text builders which can convert the formatted text in the text
 edit to all kinds of markup, like HTML or BBCODE.
 .
 This package contains the arch independent files.

Package: libkf5pimtextedit-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libkf5pimtextedit5abi2 (= ${binary:Version}),
         libkf5syntaxhighlighting-dev (>= 5.99.0~),
         libkf5textwidgets-dev (>= 5.99.0~),
         ${misc:Depends},
Description: libkf5pimtextedit - development files
 KPIMTextedit provides a textedit with PIM-specific features. It also provides
 so-called rich text builders which can convert the formatted text in the text
 edit to all kinds of markup, like HTML or BBCODE.
 .
 This package contains the development files.

Package: libkf5pimtextedit-plugins
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends},
Description: library that provides a textedit with PIM-specific features - plugins
 KPIMTextedit provides a textedit with PIM-specific features. It also provides
 so-called rich text builders which can convert the formatted text in the text
 edit to all kinds of markup, like HTML or BBCODE.
 .
 This package contains the plugin for Qt Designer.

Package: libkf5pimtextedit5abi2
X-Debian-ABI: 2
X-CMake-Target: KF5PimTextEdit
Architecture: any
Multi-Arch: same
Depends: libkf5pimtextedit-data (= ${source:Version}),
         ${misc:Depends},
         ${shlibs:Depends},
Recommends: libkf5pimtextedit-plugins,
Description: library that provides a textedit with PIM-specific features
 KPIMTextedit provides a textedit with PIM-specific features. It also provides
 so-called rich text builders which can convert the formatted text in the text
 edit to all kinds of markup, like HTML or BBCODE.
 .
 This package is part of the KDE Development Platform PIM libraries module.
Provides: ${ABI:VirtualPackage},

## kpimtextedit 23.08.0

=== debian/changelog ===
kpimtextedit (23.08.0-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.08.0)

 -- Rik Mills <rikmills@kde.org>  Thu, 24 Aug 2023 12:58:16 +0100

kpimtextedit (23.07.90-0ubuntu1) mantic; urgency=medium

  * New upstream (beta) release (23.07.80)
  * New upstream (RC) release (23.07.90)

 -- Rik Mills <rikmills@kde.org>  Tue, 15 Aug 2023 02:37:48 +0100

kpimtextedit (23.04.3-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.04.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 06 Jul 2023 14:52:16 +0100

kpimtextedit (23.04.2-0ubuntu2) mantic; urgency=medium

  * Add libkf5textaddons-dev to -dev package depends.

 -- Rik Mills <rikmills@kde.org>  Thu, 15 Jun 2023 12:00:37 +0100

kpimtextedit (23.04.2-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.04.1)
  * Rename library libkf5pimtextedit5abi3 -> libkpim5textedit5
  * Update installed files
  * Drop enable_debian_abi_manager.diff
  * Sync debian/rules with debian, provide virtual ABI package
  * Remove symbols files, no longer used
  * Rename data package: libkf5pimtextedit-data -> libkpim5textedit-data
  * Add libkf5textaddons-dev to Build-Depends
  * New upstream release (23.04.2)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Mon, 12 Jun 2023 13:00:33 +0100

kpimtextedit (22.12.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 02 Mar 2023 00:41:55 +0000

kpimtextedit (22.12.2-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.2)

 -- Simon Quigley <tsimonq2@kubuntu.org>  Sat, 11 Feb 2023 14:22:49 -0600

kpimtextedit (22.12.1-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.1)

 -- Rik Mills <rikmills@kde.org>  Mon, 09 Jan 2023 17:27:01 +0000

kpimtextedit (22.12.0-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.12.0)

 -- Rik Mills <rikmills@kde.org>  Fri, 09 Dec 2022 19:13:22 +0000

kpimtextedit (22.11.90-0ubuntu1) lunar; urgency=medium

  * New upstream (RC) release (22.11.90)

 -- Rik Mills <rikmills@kde.org>  Fri, 25 Nov 2022 16:09:37 +0000

kpimtextedit (22.11.80-0ubuntu1) lunar; urgency=medium

  * New upstream (beta) release (22.11.80)

 -- Rik Mills <rikmills@kde.org>  Thu, 17 Nov 2022 10:40:26 +0000

kpimtextedit (22.08.3-0ubuntu1) lunar; urgency=medium

  * New upstream release (22.08.2)
  * New upstream release (22.08.3)

 -- Rik Mills <rikmills@kde.org>  Mon, 07 Nov 2022 11:12:39 +0000

## kpimtextedit 23.08.1

=== debian/changelog ===
kpimtextedit (23.08.1-0ubuntu1) mantic; urgency=medium

  * New upstream release (23.08.1)

 -- Rik Mills <rikmills@kde.org>  Thu, 14 Sep 2023 12:03:15 +0100

## kpimtextedit 23.08.4

=== debian/changelog ===
kpimtextedit (23.08.4-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.4)

 -- José Manuel Santamaría Lema <panfaust@gmail.com>  Wed, 13 Dec 2023 10:19:28 +0000

kpimtextedit (23.08.3-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.3)

 -- Rik Mills <rikmills@kde.org>  Thu, 09 Nov 2023 11:39:35 +0000

kpimtextedit (23.08.2-0ubuntu1) noble; urgency=medium

  * New upstream release (23.08.2)

 -- Rik Mills <rikmills@kde.org>  Thu, 26 Oct 2023 12:35:24 +0100
